local cond_Ecb_result= not GAMESTATE:IsHumanPlayer(PLAYER_1)

local cond_Fcb_result= not GAMESTATE:IsHumanPlayer(PLAYER_2)

local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "actor_adb",
  Def.Quad{
    Name= "actor_bdb",
    InitCommand= function (self)
			mawaru_magnet_note = {}
			mawaru_magnet_nptr = 1;
			mawaru_magnet_dirs = {90,0,180,-90}
			
			function mawaru_magnet_nextn()
				mawaru_magnet_nptr = mawaru_magnet_nptr+1;
				if mawaru_magnet_nptr > table.getn(mawaru_magnet_note) then
					mawaru_magnet_nptr = 1
				end
			end
			
			mawaru_magnet_scale = 0.8;
			mawaru_magnet_speedmod = 1.5;
			
			mawaru_magnet_axs = {-96,-32,32,96};
			mawaru_magnet_rots = {-180,-90,90,180};
			
			mawaru_magnet_mult = {0,0,0.1,0.25,1,2};
			mawaru_magnet_early = {1,0.5,0.25,0.1,0,0};
			
			function mawaru_magnet_gety(pn,beat)
				return (SCREEN_CENTER_Y+(SCREEN_HEIGHT*0.35*math.sin(math.pi*(beat/8)*(_G['mawaru_speedmodP'..pn]/2))))
			end
			
			function mawaru_magnet_quantize(obj, b)
				local r = b-math.floor(b)
				if r == 0 then mawaru_magnet_color(obj,4)
				elseif r == 0.5 then mawaru_magnet_color(obj,8)
				elseif (r > 0.33 and r < 0.34) or (r > 0.66 and r < 0.67) then mawaru_magnet_color(obj,12)
				elseif r == 0.25 or r == 0.75 then mawaru_magnet_color(obj,16)
				elseif (r > 0.166 and r < 0.167) or (r > 0.83 and r < 0.84) then mawaru_magnet_color(obj,12)
				elseif r == 0.125 or r == 0.375 or r == 0.625 or r == 0.875 then mawaru_magnet_color(obj,32)
				else mawaru_magnet_color(obj,64) end
			end
			
			function mawaru_magnet_color(obj, n)
				if n == 4 then obj:diffuse(1,0.4,0.3,1); end
				if n == 8 then obj:diffuse(0.3,0.7,1,1); end
				if n == 12 then obj:diffuse(1,0.4,1,1); end
				if n == 16 then obj:diffuse(0.3,1,0.4,1); end
				if n == 32 then obj:diffuse(1,0.8,0.3,1); end
				if n == 64 then obj:diffuse(0.3,1,0.7,1); end
			end
			
			function mawaru_magnet_placenote(pn,time,dir)
				
				local speed = RATEMOD*mawaru_magnet_speedmod;
			
				local beat = GAMESTATE:GetSongBeat();
				
				--Trace('aptr: '..mawaru_magnet_nptr)
				
				local a = mawaru_magnet_note[mawaru_magnet_nptr];
				if not a then return end
				
				local b = a.actor;
				
				b:visible(true);
				
				b:diffusealpha(0);
				
				mawaru_magnet_quantize(b, time);
				
				b:glow(1,1,1,0);
				b:zoom(1)
				
				b:x((SCREEN_WIDTH*-0.25)+(pn*SCREEN_CENTER_X)+(mawaru_magnet_axs[dir]*1.3));
				b:y((SCREEN_CENTER_Y));
				b:rotationz(mawaru_magnet_dirs[dir]+(mawaru_magnet_rots[dir]*mawaru_magnet_mult[_G['mawaru_difficultyP'..pn]+1]));
				
				b:accelerate(2*(60/160)/speed);
				b:x((SCREEN_WIDTH*-0.25)+(pn*SCREEN_CENTER_X)+(mawaru_magnet_axs[dir]));
				b:y(mawaru_magnet_gety(pn,time));
				b:rotationz(mawaru_magnet_dirs[dir]);
				b:diffusealpha(4);
				
				b:sleep(mawaru_magnet_early[_G['mawaru_difficultyP'..pn]+1]*(60/160)/RATEMOD);
				b:glow(1,1,1,1);
				b:decelerate(.2*(60/160)/speed);
				b:zoom(0.6);
				b:diffusealpha(0);
				
				b:queuecommand('Hide');
				
				mawaru_magnet_nextn();
			end
			
			--{beat,dir}
			--x and y are measured in percentage of a screen
			mawaru_magnet_charts = {
				--novice
				{
					{244,1},
					{248,1},
					
					{252,2},
					{256,2},
					
					{260,3},
					{264,3},
					
					{268,4},
					{272,4},
				},
				--easy
				{
					{244,1},
					{246,4},
					{248,1},
					
					{252,2},
					{254,3},
					{256,2},
					
					{260,3},
					{262,2},
					{264,3},
					
					{268,4},
					{270,1},
					{272,4},
				},
				--medium
				{
					{244,1},
					{245,2},
					{246,1},
					{248,4},
					{249,2},
					{250,4},
					{252,1},
					{254,1},
					{256,4},
					{258,4},
					
					{260,1},
					{261,2},
					{262,3},
					{264,4},
					{265,2},
					{266,3},
					{268,1},
					{269,2},
					{270,1},
					{272,4},
					{273,1},
					{274,3},
				},
				--hard
				{
					
					{244,4},
					{245,3},
					{246,2},
					{247,1},
					{248,3},
					{248.5,1},
					{249,4},
					{249.5,1},
					{250,3},
					{251,2},
					
					{252,4},
					{252.5,1},
					{253,4},
					{254,1},
					{255,4},
					{256,1},
					{256.5,2},
					{257,3},
					{258,2},
					{259,1},
					
					{260,4},
					{260.5,1},
					{261,2},
					{262,1},
					{263,4},
					{264,1},
					{264.5,2},
					{265,3},
					{266,2},
					{266.5,3},
					{267,4},
					
					{268.25,1},
					{268.75,4},
					{269,2},
					
					{270.25,3},
					{270.75,3},
					{271.5,1},
					{272.25,2},
					{272.75,3},
					
					{273.75,4},
					{274.25,1},
					{274.75,3},
					
				},
				--expert
				{
					{244.25,4},
					{244.75,1},
					{245,2},
					{246.25,3},
					{246.5,2},
					{246.75,1},
					{247,4},
					{247.5,2},
					{248.5,4},
					{249,1},
					{249.5,3},
					{250,2},
					{250.75,4},
					{251.25,1},
					{251.5,4},
					{252.25,1},
					{252.5,3},
					{252.75,1},
					{253,2},
					{253.5,1},
					{254,4},
					{254.75,3},
					{255,4},
					{255.5,1},
					{256.5,2},
					{257,3},
					{257.5,4},
					{258.25,2},
					{258.5,3},
					{259,1},
					{259.5,4},
					{260,1},
					{260.25,3},
					{260.5,1},
					{260.75,3},
					{261,1},
					{261.5,4},
					{262,3},
					{262.75,2},
					{263.5,1},
					{264,4},
					{264.5,1},
					{265,2},
					{265.5,3},
					{266,4},
					{266.5,2},
					{267.25,3},
					{267.5,1},
					{268.25,2},
					{268.75,3},
					{269,4},
					{270.25,2},
					{270.75,3},
					{271.5,2},
					{272.25,4},
					{272.75,1},
					{273.75,3},
					{274.25,2},
					{274.75,4}
				},
				--slumpage
				{
					{244,1,1},
					{244.25,2,1},
					{244.5,3,1},
					{244.75,4,1},
					{245,1,1},
					{245.5,3,1},
					{246,2,1},
					{246.25,4,1},
					{246.5,2,1},
					{247,3,1},
					{247.5,1,1},
					{248,4,1},
					{248.25,3,1},
					{248.5,2,1},
					{248.75,1,1},
					{249,4,1},
					{249.5,1,1},
					{250,3,1},
					{250.25,2,1},
					{250.5,3,1},
					{251,1,1},
					{251.25,4,1},
					{251.5,1,1},
					{252,4,1},
					{252.25,2,1},
					{252.5,3,1},
					{252.75,1,1},
					{253,4,1},
					{253.5,3,1},
					{254,2,1},
					{254.5,1,1},
					{254.75,4,1},
					{255,1,1},
					{255.5,3,1},
					{256,2,1},
					{256.25,4,1},
					{256.5,2,1},
					{257,3,1},
					{257.5,1,1},
					{258,2,1},
					{258.25,3,1},
					{258.5,4,1},
					{259,1,1},
					{260,4,1},
					{260.25,2,1},
					{260.5,3,1},
					{260.75,1,1},
					{261,3,1},
					{261.25,2,1},
					{261.5,4,1},
					{262,1,1},
					{262.5,3,1},
					{262.75,2,1},
					{263.25,2,1},
					{263.5,4,1},
					{264,1,1},
					{264.25,2,1},
					{264.5,1,1},
					{265,4,1},
					{265.5,3,1},
					{266,2,1},
					{266.25,1,1},
					{266.5,4,1},
					{266.75,2,1},
					{267,4,1},
					{267.25,1,1},
					{267.5,2,1},
					{268.25,1,1},
					{268.75,4,1},
					{269,2,1},
					{270.25,3,1},
					{270.75,2,1},
					{271.5,1,1},
					{272.25,2,1},
					{272.75,3,1},
					{273.75,1,1},
					{274.25,4,1},
					{274.75,3,1},
				}
			}
			
			mawaru_magnet_curnotep1 = 1;
			mawaru_magnet_curnotep2 = 1;
			
		end,
    KillCommand= function(self)
			--any cleanup, if necessary
		end,
    StartCommand= function(self)
			
			--variables set up when a game is started
			--wait 2 seconds (for the curtain or whatever) before accepting any inputs
			mawaru_magnet_lockinput = {2,2};
			
			mawaru_magnet_chartp1 = mawaru_magnet_charts[mawaru_difficultyP1+1]
			mawaru_magnet_chartp2 = mawaru_magnet_charts[mawaru_difficultyP2+1]
			
			self:sleep(0.02);
			self:queuecommand('Update');

		end,
    UpdateCommand= function(self)
			
			--game logic
			
			local beat = GAMESTATE:GetSongBeat();
			
			for pn=1,2 do
				
				if GAMESTATE:IsHumanPlayer(pn-1) then
				
					_G['mawaru_magnet_p'..pn]:y(mawaru_magnet_gety(pn,beat));
				
					if _G['mawaru_magnet_curnotep'..pn]<=table.getn(_G['mawaru_magnet_chartp'..pn]) then
						local c = _G['mawaru_magnet_chartp'..pn][_G['mawaru_magnet_curnotep'..pn]]
						if beat>=c[1]-(2/mawaru_magnet_speedmod)-(mawaru_magnet_early[_G['mawaru_difficultyP'..pn]+1]*1) then
							if beat<c[1] then
								--mawaru_magnet_placenote(pn,time,dir)
								mawaru_magnet_placenote(pn,c[1],c[2])
							end
							_G['mawaru_magnet_curnotep'..pn] = _G['mawaru_magnet_curnotep'..pn]+1;
							Trace('PlaceArrow');
						end
					end
				end
				
			end
			
			self:sleep(0.02);
			if mawaru_curgame == 5 then
				self:queuecommand('Update');
			end
			
		end,
  },
  Def.Quad{
    Name= "actor_cdb",
    OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomto,6,SCREEN_HEIGHT;diffuse,color('1,1,1,1')),
  },
  Def.ActorFrame{
    Name= "actor_ddb",
    InitCommand= function(self) mawaru_magnet_p1 = self end,
    OnCommand= cmd(x,SCREEN_WIDTH*0.25;y,SCREEN_CENTER_Y),
    Def.Sprite{
      Name= "actor_edb",
      Frames= {
        {Frame= 0, Delay= 1},
        {Frame= 1, Delay= 1},
        {Frame= 2, Delay= 1},
        {Frame= 3, Delay= 1},
    },--"EffectClock,beat", DiffuseRamp, EffectColor1, EffectColor2, EffectDelay and EffectOffset aren't legit.
    --"effectclock,'beat'", diffuseramp, effectcolor1, effectcolor2, effect_hold_at_full and effectoffset are legit. -Kid
      OnCommand= cmd(x,-96;rotationz,90;effectclock,'beat';diffuseramp;effectcolor1,0.4,0.4,0.4,1;effectcolor2,1,1,1,1,1;
		effectperiod,0.5;effect_hold_at_full,0.5;effectoffset,0.05),
      Texture= "./receptor 4x1.png",--Wrongly converted x position. -Kid
    },
    Def.Sprite{
      Name= "actor_fdb",
      Frames= {
        {Frame= 0, Delay= 1},
        {Frame= 1, Delay= 1},
        {Frame= 2, Delay= 1},
        {Frame= 3, Delay= 1},
    },--"EffectClock,beat", DiffuseRamp, EffectColor1, EffectColor2, EffectDelay and EffectOffset aren't legit.
    --"effectclock,'beat'", diffuseramp, effectcolor1, effectcolor2, effect_hold_at_full and effectoffset are legit. -Kid
      OnCommand= cmd(x,-32;rotationz,0;effectclock,'beat';diffuseramp;effectcolor1,0.4,0.4,0.4,1;effectcolor2,1,1,1,1,1;
		effectperiod,0.5;effect_hold_at_full,0.5;effectoffset,0.05),
      Texture= "./receptor 4x1.png",--Wrongly converted x position. -Kid
    },
    Def.Sprite{
      Name= "actor_gdb",
      Frames= {
        {Frame= 0, Delay= 1},
        {Frame= 1, Delay= 1},
        {Frame= 2, Delay= 1},
        {Frame= 3, Delay= 1},
    },--"EffectClock,beat", DiffuseRamp, EffectColor1, EffectColor2, EffectDelay and EffectOffset aren't legit.
    --"effectclock,'beat'", diffuseramp, effectcolor1, effectcolor2, effect_hold_at_full and effectoffset are legit. -Kid
      OnCommand= cmd(x,32;rotationz,180;effectclock,'beat';diffuseramp;effectcolor1,0.4,0.4,0.4,1;effectcolor2,1,1,1,1,1;
		effectperiod,0.5;effect_hold_at_full,0.5;effectoffset,0.05),
      Texture= "./receptor 4x1.png",--Wrongly converted x position. -Kid
    },
    Def.Sprite{
      Name= "actor_hdb",
      Frames= {
        {Frame= 0, Delay= 1},
        {Frame= 1, Delay= 1},
        {Frame= 2, Delay= 1},
        {Frame= 3, Delay= 1},
    },--"EffectClock,beat", DiffuseRamp, EffectColor1, EffectColor2, EffectDelay and EffectOffset aren't legit.
    --"effectclock,'beat'", diffuseramp, effectcolor1, effectcolor2, effect_hold_at_full and effectoffset are legit. -Kid
      OnCommand= cmd(x,96;rotationz,-90;effectclock,'beat';diffuseramp;effectcolor1,0.4,0.4,0.4,1;effectcolor2,1,1,1,1,1;
		effectperiod,0.5;effect_hold_at_full,0.5;effectoffset,0.05),
      Texture= "./receptor 4x1.png",--Wrongly converted x position. -Kid
    },
  },
  Def.ActorFrame{
    Name= "actor_idb",
    InitCommand= function(self) mawaru_magnet_p2 = self end,
    OnCommand= cmd(x,SCREEN_WIDTH*0.75;y,SCREEN_CENTER_Y),
    Def.Sprite{
      Name= "actor_jdb",
      Frames= {
        {Frame= 0, Delay= 1},
        {Frame= 1, Delay= 1},
        {Frame= 2, Delay= 1},
        {Frame= 3, Delay= 1},
    },--"EffectClock,beat", DiffuseRamp, EffectColor1, EffectColor2, EffectDelay and EffectOffset aren't legit.
    --"effectclock,'beat'", diffuseramp, effectcolor1, effectcolor2, effect_hold_at_full and effectoffset are legit. -Kid
      OnCommand= cmd(x,-96;rotationz,90;effectclock,'beat';diffuseramp;effectcolor1,0.4,0.4,0.4,1;effectcolor2,1,1,1,1,1;
		effectperiod,0.5;effect_hold_at_full,0.5;effectoffset,0.05),
      Texture= "./receptor 4x1.png",--Wrongly converted x position. -Kid
    },
    Def.Sprite{
      Name= "actor_kdb",
      Frames= {
        {Frame= 0, Delay= 1},
        {Frame= 1, Delay= 1},
        {Frame= 2, Delay= 1},
        {Frame= 3, Delay= 1},
    },--"EffectClock,beat", DiffuseRamp, EffectColor1, EffectColor2, EffectDelay and EffectOffset aren't legit.
    --"effectclock,'beat'", diffuseramp, effectcolor1, effectcolor2, effect_hold_at_full and effectoffset are legit. -Kid
      OnCommand= cmd(x,-32;rotationz,0;effectclock,'beat';diffuseramp;effectcolor1,0.4,0.4,0.4,1;effectcolor2,1,1,1,1,1;
		effectperiod,0.5;effect_hold_at_full,0.5;effectoffset,0.05),
      Texture= "./receptor 4x1.png",--Wrongly converted x position. -Kid
    },
    Def.Sprite{
      Name= "actor_ldb",
      Frames= {
        {Frame= 0, Delay= 1},
        {Frame= 1, Delay= 1},
        {Frame= 2, Delay= 1},
        {Frame= 3, Delay= 1},
    },--"EffectClock,beat", DiffuseRamp, EffectColor1, EffectColor2, EffectDelay and EffectOffset aren't legit.
    --"effectclock,'beat'", diffuseramp, effectcolor1, effectcolor2, effect_hold_at_full and effectoffset are legit. -Kid
      OnCommand= cmd(x,32;rotationz,180;effectclock,'beat';diffuseramp;effectcolor1,0.4,0.4,0.4,1;effectcolor2,1,1,1,1,1;
		effectperiod,0.5;effect_hold_at_full,0.5;effectoffset,0.05),
      Texture= "./receptor 4x1.png",--Wrongly converted x position. -Kid
    },
    Def.Sprite{
      Name= "actor_mdb",
      Frames= {
        {Frame= 0, Delay= 1},
        {Frame= 1, Delay= 1},
        {Frame= 2, Delay= 1},
        {Frame= 3, Delay= 1},
    },--"EffectClock,beat", DiffuseRamp, EffectColor1, EffectColor2, EffectDelay and EffectOffset aren't legit.
    --"effectclock,'beat'", diffuseramp, effectcolor1, effectcolor2, effect_hold_at_full and effectoffset are legit. -Kid
      OnCommand= cmd(x,96;rotationz,-90;effectclock,'beat';diffuseramp;effectcolor1,0.4,0.4,0.4,1;effectcolor2,1,1,1,1,1;
		effectperiod,0.5;effect_hold_at_full,0.5;effectoffset,0.05),
      Texture= "./receptor 4x1.png",--Wrongly converted x position. -Kid
    },
  },
  Def.Model{
    Name= "actor_ndb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_odb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_pdb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_qdb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_rdb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_sdb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_tdb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_udb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_vdb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_wdb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_xdb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_ydb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_zdb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_Adb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_Bdb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_Cdb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_Ddb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_Edb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_Fdb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_aeb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_beb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_ceb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_deb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_eeb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_feb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_geb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_heb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_ieb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_jeb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_keb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_leb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_meb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_neb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_oeb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_peb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_qeb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_reb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_seb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_teb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_ueb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_veb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_web",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_xeb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_yeb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_zeb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_Aeb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_Beb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_Ceb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_Deb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_Eeb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_Feb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_afb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_bfb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_cfb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_dfb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_efb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_ffb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_gfb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_hfb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_ifb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_jfb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_kfb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_lfb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Model{
    Name= "actor_mfb",
    Bones= "arrow/arrowmesh.txt",
    HideCommand= function(self) self:visible(false); mawaru_magnet_note[self:getaux()].pn = 0 end,
    Materials= "arrow/4th.txt",
    Meshes= "arrow/arrowmesh.txt",
    OnCommand= cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
    SetMeCommand= function(self) table.insert(mawaru_magnet_note,{actor = self,pn = 0,hit = false}) self:aux(table.getn(mawaru_magnet_note)) end,
  },
  Def.Quad{
    Name= "actor_nfb",
    InitCommand= function(self) mawaru_magnet_controller = self end,
  },
  optional_actor(cond_Ecb_result,
  Def.Quad{
    Name= "actor_ofb",
    OnCommand= cmd(x,SCREEN_WIDTH*0.25;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH/2,SCREEN_HEIGHT;diffuse,color('0,0,0,1')),
  }),
  optional_actor(cond_Fcb_result,
  Def.Quad{
    Name= "actor_pfb",
    OnCommand= cmd(x,SCREEN_WIDTH*0.75;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH/2,SCREEN_HEIGHT;diffuse,color('0,0,0,1')),
  }),
}
